<template>
  <span :id="id">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType == 'hidden'"
    >
      <div class="component-o-calctext" v-if="field.hiddenValue">{{field.hiddenValue}}</div>
      <!-- <div class="mint-cell mint-field" v-if="field.hiddenValue">
        <div class="mint-cell-wrapper">
          <div class="mint-cell-title">
            <span class="mint-cell-text">{{field.value?field.value:field.name}}</span>
          </div> 
          <div class="mint-cell-value hidden">
            <span>{{field.hiddenValue}}</span>
          </div>
        </div>
      </div> -->
    </template>
    <!--只读-->
    <template v-else-if="field.textType == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <template v-if="field.readOnlyShowValOnly">
        <mt-button
          disabled
          class="btn" 
          type="primary" 
          size="small" 
          :style="{'background-color':field.activity.colorType ? field.activity.colorType : ''}"
          :title="field.title" 
          @click="checkValue" 
          v-if="field.title!='自定义打印'"
        >
          {{field.value}}
        </mt-button>
      </template>
      <template v-else>
      </template>
    </template>

    <!-- 可编辑 -->
    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY && field.hiddenBtn" >
        <!-- <a  class="btns" type="primary" :title="field.title" @click="checkValue" v-if="field.title!='自定义打印'">
          <i class="saveBtnicon"></i>
          {{field.value}}
        </a> -->
      
        <mt-button
          class="btn" 
          type="primary" 
          size="small" 
          :title="field.title" 
          @click="checkValue" 
          v-if="field.title!='自定义打印'"
          :style="{'background-color':field.activity.colorType ? field.activity.colorType : ''}"
        >
          {{field.title?field.title:field.name}}
        </mt-button>
    </template>
  </span>
</template>

<script>
import Constant from "@/Constant.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-button",
  props: ["id"],
  computed: {
    field: function() {
      let allData = this.$parent.findField(this.id);
      if(allData.activityType && ( 
        allData.activityType == 14 || 
        // allData.activityType == 8 || 
        allData.activityType == 15 || 
        allData.activityType == 30 || 
        allData.activityType == 25 || 
        allData.activityType == 26 || 
        // allData.activityType == 43 || 
        allData.activityType == 46
      )) {
        allData.hiddenBtn = false
      }else {
        allData.hiddenBtn = true;
      }
      //activityType 13,34,14,8,15,30,25,26,43,46
      return allData;
    }
  },

  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },

  data: function() {
    return { 
      Constant,
    };
  },
  methods: {
    checkValue(){
      let field = this.field;
      let divId = field.divId;
      let refreshOnChanged = field.refreshOnChanged;
      let id = this.id;
      let activityType = field.activityType;
      let activity = field.activity;
      delete activity.hiddenScript;
      delete activity.dispatcherUrl;
      delete activity.actionScript;
      let params = {
        divId, 
        refreshOnChanged, 
        id, 
        activityType,
        activity
      };
      console.log(params)

      let paramsJson = JSON.stringify(params);
      let havePar = false;
      let par  = '';

      while(!havePar) {
        par = par + '.$parent';
        let url = 'this' + par + '.onClickButtonControl';
        if(eval(url)) {
          let path = url+"("+paramsJson+")"
          eval(path);
          break
        }
      }
      // this.$parent.$parent.$parent.$parent.runBeforeAction(divId, refreshOnChanged, id, activityType, this.field.activity);
    },
  }
};
</script>